'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _vm = require('vm');

var _vm2 = _interopRequireDefault(_vm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function clone(obj) {
  if (null == obj || 'object' != typeof obj) return obj;
  var copy = obj.constructor();
  for (var attr in obj) {
    if (obj.hasOwnProperty(attr)) copy[attr] = obj[attr];
  }
  return copy;
}

module.exports = function evalComponentCode(code) {
  try {
    const script = new _vm2.default.Script(code, {});

    // Fake require
    function fakeRequire() {}
    fakeRequire.default = fakeRequire;

    let requireSanbox = function (element) {
      // depending on the preset that one is running,
      // babel will not always use the root interopRequireDefault
      // for babel es6, it uses .../builtin/es6/interop...
      if (/@babel[\\,\/]runtime\/helpers\/.*interopRequireDefault$/.test(element)) {
        return function (value) {
          return value;
        };
      }
      if (element === 'vuex') {
        const outputVuex = {
          mapState: function () {},
          mapMutations: function () {},
          mapGetters: function () {},
          mapActions: function () {},
          createNamespacedHelpers: function () {}
        };
        return _extends({}, outputVuex, {
          default: outputVuex
        });
      }
      if (element === 'vue') {
        const outputVue = {
          __esModule: true,
          use: function use() {},
          directive: function use() {},
          component: function component() {},
          extended: function extended() {},
          extend: function (obj) {
            return obj;
          }
        };
        return _extends({}, outputVue, {
          default: outputVue
        });
      }
      return fakeRequire;
    };
    requireSanbox.context = function () {
      return function () {};
    };
    const sandbox = {
      exports: {},
      module: {
        exports: {}
      },
      require: requireSanbox,
      document: {},
      window: {
        location: {}
      },
      alert: function () {},
      confirm: function () {},

      console: {
        log: function () {},
        debug: function () {}
      },
      sessionStorage: {
        getItem: function () {},
        setItem: function () {},
        removeItem: function () {}
      },
      localStorage: {
        getItem: function () {},
        setItem: function () {},
        removeItem: function () {}
      }
    };
    const context = new _vm2.default.createContext(sandbox);
    script.runInContext(context);
    const output = sandbox;
    return clone(output);
  } catch (err) {
    throw err;
  }
};