'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = processMethods;

var _getMethod = require('./getMethod');

var _getMethod2 = _interopRequireDefault(_getMethod);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function processMethods(docFile, component) {
  docFile = docFile.slice();
  let methods = component.methods;
  const listDocMethods = [];
  let mixins = component.mixins;
  if (mixins) {
    mixins.forEach(mixin => {
      const mMixin = mixin.methods;
      if (mMixin) {
        methods = Object.assign({}, mMixin, methods);
      }
    });
  }
  if (methods) {
    const listDocParts = [];
    Object.keys(methods).forEach(methodName => {
      const docPart = docFile.reverse().filter(comment => {
        return comment.longname.indexOf('methods.' + methodName) > -1 && listDocParts.indexOf(comment.longname) === -1;
      })[0];
      if (docPart) {
        if (docPart['access'] && docPart['access'] === 'public') {
          listDocParts.push(docPart.longname);
          listDocMethods.push((0, _getMethod2.default)(methodName, docPart));
        }
      }
    });
  }
  return listDocMethods;
}